<template>
  <div class="SelectGird">
    <div class="header-middle">
      <div class="hint">
        <span v-for="(item, index) in slectList" :key="index"><span v-if="index" style="margin:0 4px;">/</span><span style="color:#3F8DF5" @click="girdNameClick(item, index)">{{item.girdName}}</span></span>
      </div>
      <div class="showTypes">
        <div v-if="treeList.length > 0">
          <div class="cards" v-for="(item, index) in treeList" :key="index" @click="itemClick(item)">
            <div class="imges">
              <span>
                <img src="./components/img/xzh.png" alt="" class="imgselect" v-if="item.isChecked" @click.stop="girdClick(item, index)" />
                <img src="./components/img/xz.png" alt="" class="imgselect" v-else @click.stop="girdClick(item, index)" />
              </span>
              <img src="./components/img/gird--select-icon.png" alt="" class="avatras" />
            </div>
            <div class="rightes">
              <div class="applicationNames">{{ item.girdName }}</div>
              <img src="./components/img/right-icon.png" alt="" class="imgs" v-if="item.girdLevel != 2"/>
            </div>
          </div>
        </div>

        <AiEmpty description="暂无数据" class="emptyWrap" v-else></AiEmpty>
      </div>
    </div>
    <!-- <div style="padding-bottom: 70px;"></div> -->
    <div class="subBtn" @click="submit">
      <div>确定选择</div>
    </div>

  </div>
</template>

<script>
export default {
  name: 'SelectGird',
  data() {
    return {
      SelectGird: {},
      allData: null,
      treeList: [],
      slectList: [],
      userGird: {},
      userList: [],
      girdLevel: 0,
      parentGirdId: ''
    }
  },
  onLoad() {
    this.isGirdUser()
  },
  methods: {
    isGirdUser() {
      this.$http.post('/app/appgirdmemberinfo/checkLogOnUser').then((res) => {
        if (res.code == 0) {
          if (res.data.checkType) {
            this.userGird = res.data
            this.getTree()
          } else {
            this.$u.toast('当前人员不是网格员或网格管理员')
          }
        }
      })
    },
    getTree() {
      this.slectList = []
      this.$http.post(`/app/appgirdinfo/queryAppGirdInfoByGirdLevel?girdLevel=${this.girdLevel}&girdMemberId=${this.userGird.girdMemberId}&parentGirdId=${this.parentGirdId}`).then((res) => {
        if (res?.data) {
          this.allData = res.data
          this.treeInit()
        }
      })
    },

    treeInit() {
      this.treeList = this.allData
      this.treeList.map((item) => {
        item.isChecked = false
      })
      var obj = {
        girdName: '可选范围',
        id: '',
        girdLevel: ''
      }
      this.slectList.push(obj)
    },

    itemClick(row) {
      if(row.girdLevel == 2) return
      var obj = {
        girdName: row.girdName,
        id: row.id,
        girdLevel: row.girdLevel
      }
      this.slectList.push(obj)
      this.searckGird(row)
    },

    searckGird(row) {
      if(row.girdLevel == 2) return
      var girdLevel = Number(row.girdLevel)+1
      this.$http.post(`/app/appgirdinfo/queryAppGirdInfoByGirdLevel?girdLevel=${girdLevel}&girdMemberId=${this.userGird.girdMemberId}&parentGirdId=${row.id}`).then((res) => {
        if (res?.data) {
          this.treeList = res.data
        }
      })
    },

    girdNameClick(row, index) {
      this.userList = []
      if(!index) { //第一级别
        this.slectList = []
        this.treeInit()
      }else {
        var list = []
        this.slectList.map((item, i) => {
          if(i <= index) {
            list.push(item)
          }
        })
        this.slectList = list
        this.searckGird(row)
      }
    },
    

    girdClick(row, index) {
      if (this.treeList[index].isChecked) {//取消
        this.treeList[index].isChecked = false
        this.SelectGird = {}
      } else {
        this.treeList.map((item) => {
          item.isChecked = false
        })
        this.treeList[index].isChecked = true
        this.SelectGird = row
      }
      this.$forceUpdate()
    },


    submit() {
      if (this.SelectGird.id != null) {
        uni.$emit('goback', this.SelectGird)
        console.log(this.SelectGird)
        uni.navigateBack()
      } else {
        return this.$u.toast('请选择网格')
      }
    },
  }
}
</script>

<style scoped lang="scss">
.SelectGird {
  height: 100%;
  background: #fff;
  padding-bottom: 140px;
  .header-top {
    background: #fff;
    padding: 20px 32px;
  }

  .header-middle {
    .hint {
      padding: 28px 20px 28px 32px;
      line-height: 56px;
      box-shadow: 0px 1px 0px 0px #e4e5e6;
      font-size: 30px;
      font-weight: 500;
      word-break: break-all;
    }

    .showTypes {
      .empty-div {
        height: 16px;
        background: #f5f5f5;
      }

      .cards {
        display: flex;
        align-items: center;
        height: 120px;
        line-height: 120px;
        // background: pink;
        padding: 0 0 0 32px;

        .imges {
          display: flex;
          align-items: center;
          // width: 200px;
          .imgselect {
            width: 48px;
            height: 48px;
            vertical-align: middle;
          }

          .avatras {
            width: 74px;
            height: 74px;
            border-radius: 8px;
            margin-left: 36px;
          }
        }
        img {
          width: 74px;
          height: 74px;
          border-radius: 8px;
        }
        .rightes {
          width: calc(100% - 188px);
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-left: 32px;
          border-bottom: 1px solid #e4e5e6;
          .applicationNames {
            width: calc(100% - 56px);
            font-size: 36px;
            font-weight: 500;
            color: #333333;
            overflow:hidden; 
            text-overflow:ellipsis; 
            white-space:nowrap;
          }
          .imgs {
            width: 40px;
            height: 40px;
            vertical-align: middle;
          }
        }
      }
    }

    .showUsers {
      .cards {
        display: flex;
        align-items: center;
        height: 120px;
        line-height: 120px;
        // background: pink;
        padding: 0 0 0 32px;

        .imges {
          display: flex;
          align-items: center;
          width: 200px;
          .imgselect {
            width: 48px;
            height: 48px;
          }

          .avatras {
            width: 74px;
            height: 74px;
            border-radius: 8px;
            margin-left: 36px;
          }
        }

        .rights {
          width: 100%;
          display: flex;
          justify-content: space-between;
          align-items: center;
          margin-left: 32px;
          border-bottom: 1px solid #e4e5e6;
          padding-right: 40px;
          .applicationNames {
            font-size: 36px;
            font-weight: 500;
            color: #333333;
          }
          .idNumbers {
            color: #666;
          }
        }
      }
    }
  }

  .subBtn {
    position: fixed;
    bottom: 0;
    left: 0;
    width: 100%;
    height: 118px;
    background: #f4f8fb;
    div {
      width: 192px;
      height: 80px;
      line-height: 80px;
      text-align: center;
      background: #1365dd;
      border-radius: 4px;
      font-size: 32px;
      color: #fff;
      margin: 20px 34px 0 0;
      float: right;
    }
  }

}
</style>
